/*
    artifact generator: C:\My\wizzi\v5\node_modules\wizzi-js\lib\artifacts\js\module\gen\main.js
    primary source IttfDocument: c:\my\wizzi\v5\kernel\wizzi\src\ittf\root\index.js.ittf
    utc time: Sat, 09 Jun 2018 11:00:53 GMT
*/
'use strict';
var verify = require('wizzi-utils').verify;
var util = require('util');
var path = require('path');
var chalk = require('chalk');

var verify = require('wizzi-utils').verify;
var file = require('wizzi-utils').file;
var config = require('wizzi-utils').config;
var log = require('./lib/util/log')(module);
var acl = require('./lib/acl');
var productionOptions = require('./lib/production/options');
var ProductionManager = require('./lib/production/manager');
var Filesystem = require('./lib/io/filesystem');
var wizziFactory = require('./lib/services/wizziFactory');

var md = module.exports = {};
md.file = file;
md.verify = verify;
md.config = config;
md.acl = acl;
md.productionOptions = productionOptions;
md.Filesystem = Filesystem;

/** -àà
     params
     string userid
     string role
     { options
     { repo
     string storeKind
     oneOf filesystem, mongodb, localstorage
     { plugins
     [ items
     string pluginName
     string
     { globalContext:Object
     { dumps
     string dumpsBaseFolder
     { mTreeBuildUpScript
     boolean dump
     string dumpsBaseFolder
*/
md.createFactory = function createFactory(userid, role, options, callback) {
    if (typeof(callback) !== 'function') {
        throw new Error(
            error('InvalidArgument', 'createFactory', 'The callback parameter must be a function. Received: ' + callback)
        );
    };
    if (verify.isNotEmpty(userid) === false) {
        return callback(error(
            'InvalidArgument', 'createFactory', { parameter: 'userid', message: 'The userid parameter must be a string. Received: ' + userid }
        ));
    }
    if (verify.isNotEmpty(role) === false) {
        return callback(error(
            'InvalidArgument', 'createFactory', { parameter: 'role', message: 'The role parameter must be a string. Received: ' + role }
        ));
    }
    if (verify.isObject(options) === false) {
        return callback(error(
            'InvalidArgument', 'createFactory', { parameter: 'options', message: 'The options parameter must be an object. Received: ' + options }
        ));
    }
    
    // check_cb( callback, createFactory )
    // check_cb_object( options, createFactory )
    
    wizziFactory.createFactory(userid, role, options, callback);
};

md.fsnoaclFactory = function(options, callback) {
    
    if (typeof(callback) === 'undefined') {
        callback = options;
        options = {};
    }
    
    if (verify.isFunction(callback) == false) {
        throw new Error(error(101, 'createFactory', "Parameter 'callback' must be a function. Received: " + util.inspect(callback, { depth: null })));
    }
    if (verify.isObject(options) == false) {
        return callback(error(101, 'createFactory', "Parameter 'options' must be an object. Received: " + util.inspect(options, { depth: null })));
    }
    
    options.repo = {
        storeKind: 'filesystem'
    };
    md.createFactory('stefi', 'admin', options, callback);
};

md.dbnoaclFactory = function(storeUri, storeBaseFolder, options, callback) {
    if (typeof(callback) !== 'function') {
        throw new Error(
            error('InvalidArgument', '', 'The callback parameter must be a function. Received: ' + callback)
        );
    };
    if (verify.isNotEmpty(storeUri) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'storeUri', message: 'The storeUri parameter must be a string. Received: ' + storeUri }
        ));
    }
    if (verify.isNotEmpty(storeBaseFolder) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'storeBaseFolder', message: 'The storeBaseFolder parameter must be a string. Received: ' + storeBaseFolder }
        ));
    }
    if (verify.isObject(options) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'options', message: 'The options parameter must be an object. Received: ' + options }
        ));
    }
    
    console.log('wizzi.index.dbnoaclFactory.storeUri,storeBaseFolder', storeUri, storeBaseFolder);
    
    options.repo = {
        storeKind: 'mongodb', 
        storeUri: storeUri, 
        storeBaseFolder: storeBaseFolder
    };
    md.createFactory('stefi', 'admin', options, callback);
};

md.jsonnoaclFactory = function(options, callback) {
    if (typeof(callback) !== 'function') {
        throw new Error(
            error('InvalidArgument', '', 'The callback parameter must be a function. Received: ' + callback)
        );
    };
    if (verify.isObject(options) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'options', message: 'The options parameter must be an object. Received: ' + options }
        ));
    }
    if (verify.isObject(options.jsonFsData) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'options.jsonFsData', message: 'The options.jsonFsData parameter must be an object. Received: ' + options.jsonFsData }
        ));
    }
    
    console.log('wizzi.index.jsonnoaclFactory.jsonFsData', options.jsonFsData);
    
    options.repo = {
        storeKind: 'json', 
        storeJsonFsData: options.jsonFsData
    };
    md.createFactory('stefi', 'admin', options, callback);
};

/** -àà
     startRunnerServer is async.
     Can be used at startup to load wizzi models, that is an async process,
     implementing the onStart and onPrepare callbacks in the wizzifile.
     During an mTree evaluation the calls to runnerServer
     must be sync. Both $.api(name, query) and $.model(name, query)
     are sync methods that operate on wizzi models or POJO
     previously loaded and/or prepared.
*/
md.startRunnerServer = function(options, callback) {
    if (typeof(callback) !== 'function') {
        throw new Error(
            error('InvalidArgument', '', 'The callback parameter must be a function. Received: ' + callback)
        );
    };
    if (verify.isObject(options) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'options', message: 'The options parameter must be an object. Received: ' + options }
        ));
    }
    if (verify.isNullOrUndefined(options.user) === false) {
        if (verify.isNotEmpty(options.user) === false) {
            return callback(error(
                'InvalidArgument', '', { parameter: 'options.user', message: 'The options.user parameter must be a string. Received: ' + options.user }
            ));
        }
    }
    if (verify.isNullOrUndefined(options.role) === false) {
        if (verify.isNotEmpty(options.role) === false) {
            return callback(error(
                'InvalidArgument', '', { parameter: 'options.role', message: 'The options.role parameter must be a string. Received: ' + options.role }
            ));
        }
    }
    var runnerServerCWD = (options.cwd || process.cwd());
    var wizziFilePath = path.join(runnerServerCWD, 'wizzifile.js');
    if (file.isFile(wizziFilePath)) {
        md.wizzifile = require(wizziFilePath);
        console.log(chalk.yellow('WIZZI FILE FOUND on path: ' + wizziFilePath));
        if (md.wizzifile.onConfig) {
            md.wizzifile.onConfig(config, function(err, notUsed) {
                if (err) {
                    return callback(err);
                }
                var RunnerServer = require('./lib/services/runnerServer');
                RunnerServer.init(runnerServerCWD, options.user, options.role);
                if (md.wizzifile.onStart) {
                    md.wizzifile.onStart(RunnerServer.instance, config, function(err, notUsed) {
                        if (err) {
                            return callback(err);
                        }
                        if (md.wizzifile.onPrepare) {
                            RunnerServer.instance.callOnPrepare(md.wizzifile, config, function(err, notUsed) {
                                if (err) {
                                    return callback(err);
                                }
                                console.log(chalk.yellow('WIZZI RUNNER SERVER STARTED ON FOLDER ' + runnerServerCWD));
                                return callback(null);
                            });
                        }
                        else {
                            console.log(chalk.yellow('WIZZI RUNNER SERVER STARTED ON FOLDER ' + runnerServerCWD));
                            return callback(null);
                        }
                    });
                }
                else {
                    console.log(chalk.yellow('WIZZI RUNNER SERVER STARTED ON FOLDER ' + runnerServerCWD));
                    return callback(null);
                }
            });
        }
        else {
            console.log(chalk.yellow('Method wizzifile.onConfig NOT FOUND. RUNNER SERVER NOT STARTED.'));
            return callback(null);
        }
    }
    else {
        console.log(chalk.yellow('WIZZI FILE NOT FOUND. RUNNER SERVER NOT STARTED.'));
        return callback(null);
    }
};
/** -àà
     params
     { request
     string user
     default stefi
     string role
     default admin
     string storeKind
     default filesystem
     { config
     string wfBaseFolder
     string storeUri
     # when storeKind == 'mongodb'
     string storeBaseFolder
     # when storeKind == 'mongodb'
     string pluginsBaseFolder
     [ plugins
     string name
     { job
     string name
     # label for messages
     string ittfDocumentUri
     # 'wfjob' model primary ittf document
     { productionOptions
     integer indentSpaces
     default 4
     string basedir
     TODO explain where used
     integer verbose
     default 2
     { dumps
     # dumps to files of transient objects for debug purposes
     string dumpsBaseFolder
     { mTreeBuildupJsWizziScript
     boolean dump
     string dumpsBaseFolder
     { mixedMTree
     boolean dump
     string dumpsBaseFolder
     { evaluatedMTree
     boolean dump
     string dumpsBaseFolder
     { globalContext
     # Every wizzi factory loading, transformation and generation
     # executed by this job
     # will have the properties of this object injected in its context
     # at the global level.
*/
md.executeWizziJob = function(request, callback) {
    if (typeof(callback) !== 'function') {
        throw new Error(
            error('InvalidArgument', '', 'The callback parameter must be a function. Received: ' + callback)
        );
    };
    if (verify.isObject(request) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'request', message: 'The request parameter must be an object. Received: ' + request }
        ));
    }
    if (verify.isObject(request.config) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'request.config', message: 'The request.config parameter must be an object. Received: ' + request.config }
        ));
    }
    if (verify.isArray(request.config.plugins) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'request.config.plugins', message: 'The request.config.plugins parameter must be an array. Received: ' + request.config.plugins }
        ));
    }
    if (verify.isObject(request.job) === false) {
        return callback(error(
            'InvalidArgument', '', { parameter: 'request.job', message: 'The request.job parameter must be an object. Received: ' + request.job }
        ));
    }
    
    // check_cb( callback, executeWizziJob )
    // check_cb_object( request, executeWizziJob )
    // check_cb_object( request.config, executeWizziJob )
    // check_cb_object( request.job, executeWizziJob )
    
    var user = request.user || 'stefi';
    var role = request.role || 'admin';
    var storeKind = request.storeKind || 'filesystem';
    var jobName = request.job.name;
    
    console.log('=');
    console.log('======== v5.wizzi.executeWizziJob ===== Start job: ' + jobName + ' =============');
    console.log('- Executor module path ', __filename);
    console.log('- Job source path ', request.job.ittfDocumentUri);
    console.log('- user', user + '/' + role);
    console.log('- storeKind', storeKind);
    if (request.config.wfBaseFolder) {
        console.log('- wfBaseFolder', request.config.wfBaseFolder);
    }
    if (request.config.storeUri) {
        console.log('- storeUri', request.config.storeUri);
    }
    if (request.config.storeBaseFolder) {
        console.log('- storeBaseFolder', request.config.storeBaseFolder);
    }
    
    var requestConfig = Object.assign({}, request.config);
    
    var wfBaseFolder = requestConfig.wfBaseFolder;
    if (wfBaseFolder && wfBaseFolder.length > 0) {
        // FIXME property wfBaseFolder in module wizzi/config
        // should be part of the wizzi.wizziFactory instance.
        // Find where it is referenced.
        md.config.set('wfBaseFolder', wfBaseFolder);
    }
    
    console.log('- plugins');
    var plugins = [];
    var i, i_items=requestConfig.plugins, i_len=requestConfig.plugins.length, item;
    for (i=0; i<i_len; i++) {
        item = requestConfig.plugins[i];
        if (plugins.indexOf(item) < 0) {
            plugins.push(item);
            console.log('  ', item);
        }
    }
    console.log('- pluginsBaseFolder', requestConfig.pluginsBaseFolder || process.cwd());
    
    wizziFactory.createFactory(user, role, {
        repo: {
            storeKind: storeKind, 
            storeUri: requestConfig.storeUri, 
            storeBaseFolder: requestConfig.storeBaseFolder
        }, 
        plugins: {
            items: plugins, 
            pluginsBaseFolder: requestConfig.pluginsBaseFolder || process.cwd()
        }, 
        globalContext: request.job.globalContext || {}
    }, executeWizziJob_step2(request.job, callback));
};
function executeWizziJob_step2(jobRequest, callback) {
    return function(err, wizziFactoryInstance) {
            if (err) {
                return callback(err);
            }
            var jobName = jobRequest.name;
            var jobPath = jobRequest.ittfDocumentUri;
            
            console.log('=');
            console.log('======== v5.wizzi.executeWizziJob_step2 ===== job: ' + jobName + ' =============');
            console.log('=');
            
            var pman = wizziFactoryInstance.createProductionManager(jobRequest.productionOptions, jobRequest.globalContext);
            if (pman && pman.__is_error) {
                console.log('__is_error ', pman);
                return callback(pman);
            }
            
            var notUsed = pman.addJobRequest({
                wfjob: {
                    ittfDocumentUri: jobPath
                }
            });
            if (notUsed && notUsed.__is_error) {
                console.log('__is_error ', notUsed);
                return callback(notUsed);
            }
            
            pman.run(function(err, result) {
                if (err) {
                    return callback(error('RunError', 'executeWizziJob_step2', 'Running wizzi job ' + jobName + ', source: ' + jobPath, err));
                }
                console.log('=');
                log.success('======== v5.wizzi.executeWizziJob. Job: ' + jobName + '. Run completed');
                console.log('=');
                pman.persistToFile(function(err, result) {
                    if (err) {
                        return callback(error('RunError', 'executeWizziJob_step2', 'Persisting to file wizzi job ' + jobName + ', source: ' + jobPath, err));
                    }
                    console.log('=');
                    log.success('======== v5.wizzi.executeWizziJob. Job: ' + jobName + '.  PersistToFile completed');
                    console.log('=');
                    pman.terminate();
                    if (callback) {
                        callback(null, result);
                    }
                });
            });
        };
}
md.printWizziJobError = function(jobName, err) {
    err.WizziIndexStack = (new Error()).stack;
    console.log("\n");
    console.log("====================================================================================================\n");
    console.log("FATAL ERROR : v5.executing wizzi instance job: " + jobName);
    console.log("\n");
    console.log("Error message:\n");
    console.log(err.message + "\n");
    console.log("Error details:\n");
    console.log(err + "\n");
    console.log("FATAL ERROR - END\n");
    console.log("====================================================================================================\n");
    console.log("\n");
    process.exit(999);
};
/** -àà
     TODO
     Why we cannot pass the wizziFactory instance created
     for a job to the ProductionManager
     avoiding a static object that must be guarded ???
*/
var job_wizziFactory = null;

/** -àà
     start a wizzi factory instance for a job execution
*/
md.startJobWizziFactoryInstance = function(user, role, storeKind, configOptions, configJob, callback) {
    if (job_wizziFactory != null) {
        // TODO enque wizzi job requests
        throw new Error('A wizzi job already is running. Only one at a time is allowed.');
    }
    console.log('startJobWizziFactoryInstance.user', user);
    console.log('startJobWizziFactoryInstance.role', role);
    console.log('startJobWizziFactoryInstance.storeKind', storeKind);
    console.log('startJobWizziFactoryInstance.configOptions', configOptions);
    console.log('startJobWizziFactoryInstance.configJob', configJob);
    configOptions = Object.assign({}, configOptions);
    var wfBaseFolder = configOptions.wfBaseFolder;
    if (wfBaseFolder && wfBaseFolder.length > 0) {
        md.config.set('wfBaseFolder', wfBaseFolder);
    }
    var repoUri = configOptions.repoUri;
    var repoBaseFolder = configOptions.repoBaseFolder;
    var plugins = [
        'wizzi-core'
    ];
    var i, i_items=configOptions.plugins, i_len=configOptions.plugins.length, item;
    for (i=0; i<i_len; i++) {
        item = configOptions.plugins[i];
        if (plugins.indexOf(item) < 0) {
            plugins.push(item);
        }
    }
    console.log('startJobWizziFactoryInstance.plugins', plugins);
    wizziFactory.createFactory(user, role, {
        repo: {
            storeKind: storeKind
        }, 
        plugins: {
            items: plugins
        }, 
        globalContext: configJob.globalContext || {}
    }, function(err, wizziFactory) {
        if (err) {
            return callback(err);
        }
        job_wizziFactory = wizziFactory;
        console.log('*');
        console.log('* module ' + __filename);
        console.log('*');
        console.log(chalk.yellow('WIZZI PRODUCTION INSTANCE STARTED'));
        return callback(null);
    });
};

/** -àà
     terminate a wizzi instance
*/
md.terminateJobWizziFactoryInstance = function(callback) {
    job_wizziFactory = null;
    console.log(chalk.yellow('WIZZI PRODUCTION INSTANCE TERMINATED'));
    callback(null);
};
md.executeInstanceJob = function(request, callback) {
    if (verify.isFunction(callback) != true) {
        throw new Error('wizzi.executeInstanceJob requires a callback function');
    }
    if (verify.isObject(request) != true) {
        return callback(error(999, 'wizzi/index/executeInstanceJob', 'The request parameter is required'));
    }
    if (verify.isObject(request.config) != true) {
        return callback(error(999, 'wizzi/index/executeInstanceJob', 'The request.configOptions property is required'));
    }
    if (verify.isObject(request.job) != true) {
        return callback(error(999, 'wizzi/index/executeInstanceJob', 'The request.wfschema property is required'));
    }
    var user = request.user || 'stefi';
    var role = request.role || 'admin';
    var storeKind = request.storeKind || 'filesystem';
    // VIA set request.globalContext = Object.assign({}, request.globalContext)
    console.log('executeInstanceJob.user', user);
    console.log('executeInstanceJob.role', role);
    console.log('executeInstanceJob.storeKind', storeKind);
    console.log('executeInstanceJob.config', request.config);
    console.log('executeInstanceJob.job', request.job);
    md.startJobWizziFactoryInstance(user, role, storeKind, request.config, request.job, function(err, notUsed) {
        if (err) {
            return callback(err);
        }
        md.executeJob(request.job, function(err, notUsed) {
            if (err) {
                return callback(err);
            }
            md.terminateJobWizziFactoryInstance(callback);
        });
    });
};
md.executeJob = function(jobRequest, callback) {
    console.log('executeJob.jobRequest', jobRequest);
    var jobName = jobRequest.name;
    var path = jobRequest.path;
    var productionOptions = jobRequest.productionOptions;
    var globalContext = jobRequest.globalContext;
    
    var pman = job_wizziFactory.createProductionManager(productionOptions, globalContext);
    
    pman.addWfJob({
        options: {}, 
        wfjob: {
            src: path
        }
    });
    
    pman.run(function(err, result) {
        if (err) {
            var msg = 'WizziFactoryJob ' + jobName + '\nError running production: ' + path + '\n' + util.inspect(err, {depth: null});
            throw new Error(msg);
        }
        log.success('run completed');
        pman.persistToFile(function(err, result) {
            if (err) {
                var msg = 'WizziFactoryJob ' + jobName + '\nError persisting production to file: ' + path + '\n' + util.inspect(err, {depth: null});
                throw new Error(msg);
            }
            log.success('persistToFile completed');
            if (callback) {
                callback(null, result);
            }
        });
    });
};
/** -àà
     PARAMS
     { request
     string user
     default stefi
     string role
     default admin
     string storeKind
     default filesystem
     { configOptions
     { wfschema
     string name
     string ittfDocumentUri
     string outputPackageFolder
*/
md.generateWizziModelTypes = function(request, callback) {
    
    if (verify.isFunction(callback) == false) {
        throw new Error(error(101, 'generateWizziModelTypes', "Parameter 'callback' must be a function. Received: " + util.inspect(callback, { depth: null })));
    }
    if (verify.isObject(request) == false) {
        return callback(error(101, 'generateWizziModelTypes', "Parameter 'request' must be an object. Received: " + util.inspect(request, { depth: null })));
    }
    if (verify.isObject(request.configOptions) == false) {
        return callback(error(101, 'generateWizziModelTypes', "Parameter 'request.configOptions' must be an object. Received: " + util.inspect(request.configOptions, { depth: null })));
    }
    if (verify.isObject(request.wfschema) == false) {
        return callback(error(101, 'generateWizziModelTypes', "Parameter 'request.wfschema' must be an object. Received: " + util.inspect(request.wfschema, { depth: null })));
    }
    // TODO implement jsWizzi : _.toIdentifier(varName)
    // TODO check_cb_not_empty( request.wfschema.name, generateWizziModelTypes )
    // TODO check_cb_not_empty( request.wfschema.ittfDocumentUri, generateWizziModelTypes )
    // TODO check_cb_not_empty( request.wfschema.outputPackageFolder, generateWizziModelTypes )
    
    var user = request.user || 'stefi';
    var role = request.role || 'admin';
    var storeKind = request.storeKind || 'filesystem';
    
    request.wfschema.mTreeBuildUpContext = Object.assign({}, request.wfschema.mTreeBuildUpContext);
    request.globalContext = Object.assign({}, request.globalContext);
    
    console.log('generateWizziModelTypes');
    console.log('- user', user +'/' + role);
    console.log('- storeKind', storeKind);
    console.log('- configOptions', request.configOptions);
    console.log('- wfschema.name', request.wfschema.name);
    console.log('- wfschema.ittfDocumentUri', request.wfschema.ittfDocumentUri);
    console.log('- wfschema.outputPackageFolder', request.wfschema.outputPackageFolder);
    
    var repoUri = request.configOptions.repoUri;
    var repoBaseFolder = request.configOptions.repoBaseFolder;
    
    var plugins = [
        'wizzi-core'
    ];
    if (request.configOptions.plugins) {
        var i, i_items=request.configOptions.plugins, i_len=request.configOptions.plugins.length, item;
        for (i=0; i<i_len; i++) {
            item = request.configOptions.plugins[i];
            if (plugins.indexOf(item) < 0) {
                plugins.push(item);
            }
        }
    }
    console.log('- plugins', plugins);
    for (var k in request.wfschema.mTreeBuildUpContext) {
        console.log('- wfschemaContext property', k);
    }
    for (var k in request.globalContext) {
        console.log('- globalContext property', k);
    }
    
    wizziFactory.createFactory(user, role, {
        repo: {
            storeKind: storeKind
        }, 
        plugins: {
            items: plugins, 
            pluginsBaseFolder: request.configOptions.pluginsBaseFolder || process.cwd()
        }, 
        globalContext: request.globalContext
    }, function(err, wizziFactory) {
        if (err) {
            return callback(err);
        }
        // Now we can generate the wizzi model types
        // They will be written in the folder passed as second parameter.
        console.log(chalk.yellow('STARTING WIZZI MODEL TYPES GENERATION FOR SCHEMA ' + request.wfschema.name));
        wizziFactory.generateModelTypes(request.wfschema.ittfDocumentUri, request.wfschema.outputPackageFolder, request.wfschema.name, request.wfschema.mTreeBuildUpContext, function(err, result) {
            if (err) {
                return callback(err);
            }
            console.log(chalk.green('WIZZI MODEL TYPES GENERATED FOR SCHEMA ' + request.wfschema.name));
        });
    });
};

/**
  params
    string code
      # the error name or number
    string method
    string message
      # optional
    { innerError
      # optional
*/
function error(code, method, message, innerError) {
    var parameter = null;
    if (verify.isObject(message)) {
        parameter = message.parameter;
        message = message.message;
    }
    return verify.error(innerError, {
        name: ( verify.isNumber(code) ? 'Err-' + code : code ),
        method: 'wizzi.' + method,
        parameter: parameter,
        sourcePath: __filename
    }, message || 'Error message unavailable');
}
